import { MessageType as RPCMessageType } from 'vscode-jsonrpc';
import { DynamicFeature, StaticFeature, RegistrationData, BaseLanguageClient } from './client';
import { ClientCapabilities, DocumentSelector, ServerCapabilities } from './protocol';
export declare class WorkspaceFoldersFeature implements DynamicFeature<undefined> {
    private _client;
    private _listeners;
    constructor(_client: BaseLanguageClient);
    readonly messages: RPCMessageType;
    fillClientCapabilities(capabilities: ClientCapabilities): void;
    initialize(_documentSelector: DocumentSelector | undefined, _capabilities: ServerCapabilities): void;
    register(_message: RPCMessageType, data: RegistrationData<undefined>): void;
    unregister(id: string): void;
    dispose(): void;
    private asProtocol(workspaceFolder);
    private asProtocol(workspaceFolder);
}
export declare class GetConfigurationFeature implements StaticFeature {
    private _client;
    constructor(_client: BaseLanguageClient);
    fillClientCapabilities(capabilities: ClientCapabilities): void;
    initialize(_documentSelector: DocumentSelector | undefined, _capabilities: ServerCapabilities): void;
    private getConfigurations(resource, sections);
    private getConfiguration(resource, section);
}
export declare function ProposedProtocol(client: BaseLanguageClient): (StaticFeature | DynamicFeature<any>)[];
